package com.baoyin.credit.channel.activity

import android.os.Bundle
import android.os.Handler
import android.support.v7.widget.LinearLayoutManager
import android.text.TextUtils
import android.view.View
import android.widget.CompoundButton
import android.widget.Toast
import baoyin.net.BYChannelProto
import com.baoyin.credit.R
import com.baoyin.credit.base.activity.TitleBarActivity
import com.baoyin.credit.channel.action.IChannelEarlyRepayDetailAction
import com.baoyin.credit.channel.action.IChannelLoanDetailActivityAction
import com.baoyin.credit.channel.adapter.ChannelEarlyRepayPlanAdapter
import com.baoyin.credit.channel.presenter.ChannelEarlyRepayDetailPresenter
import com.baoyin.credit.channel.presenter.ChannelLoanDetailPresenter
import com.baoyin.credit.my.bean.EarlyRepayDetailBean
import com.baoyin.net.entity.EarlyRepaymentBean
import com.baoyin.preference.Constants
import com.baoyin.utils.DialogTitleUtils
import com.byxf.app_lib_persistence.SharedPreUtils
import com.byxf.utils.DateUtil
import com.byxf.utils.NumberUtil
import com.byxf.utils.ScreenUtil
import com.byxf.utils.ToastUtil
import kotlinx.android.synthetic.main.activity_channel_to_be_paid_detail.*
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.*
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.checkbox
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.coupon_tip
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.currentInterest
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.early_repay
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.error_msg
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.issue
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.liquidatedDamages
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.liquidatedDamages_layout
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.liquidatedDamages_tip
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.pay_date
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.repay_plan
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.scrollView
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.totalDueInterest
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.totalDueInterest_layout
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.totalFeeCouponAmt
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.totalFeeCouponAmt_layout
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.totalTransAmt
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.total_repayment_amt

/**
 * 提前结清-账单详情
 */
class ChannelTobePaidDetailActivity : TitleBarActivity(), IChannelEarlyRepayDetailAction,
        CompoundButton.OnCheckedChangeListener, IChannelLoanDetailActivityAction {

    var mAdapter: ChannelEarlyRepayPlanAdapter? = null
    private var loanDetailPresenter: ChannelLoanDetailPresenter? = null
    var orderNo: String = ""
    var custNo: String = ""
    private var mLoanDetailInfo: BYChannelProto.GetChannelLoanRecordEarlyRepayResponse? = null
    private var earlyRepayList: MutableList<EarlyRepayDetailBean.GetBillRepayPlan> = ArrayList<EarlyRepayDetailBean.GetBillRepayPlan>()
    private var earlyRepayDetailPresenter: ChannelEarlyRepayDetailPresenter? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_channel_to_be_paid_detail)
        mAdapter = ChannelEarlyRepayPlanAdapter(this, earlyRepayList)
        repay_plan.layoutManager = LinearLayoutManager(this)
        repay_plan.adapter = mAdapter
        orderNo = intent.extras.getString("orderNo", "")
        custNo = SharedPreUtils.getSharedPreferences(this, Constants.CHANNEL_CUST_NO, "")
        loanDetailPresenter = ChannelLoanDetailPresenter(this, this)
        loanDetailPresenter!!.queryLoanRecordEarlyRepayInfo(orderNo, custNo)
        earlyRepayDetailPresenter = ChannelEarlyRepayDetailPresenter(this, this, orderNo)
    }

    override fun getEarlyRepayDetailSuccess(earlyRepayDetailBean: EarlyRepayDetailBean?) {
        total_repayment_amt.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean!!.totalRepaymentAmt)
                .replace(",", "")
        pay_date.text = getString(R.string.str_early_repay_total_amt,
                DateUtil.getDateYearMonthDay(earlyRepayDetailBean.payDate),
                NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.installTotalAmt))
                .replace(",", "")
        totalTransAmt.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.totalTransAmt)
                .replace(",", "")
        currentInterest.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.earlyInterest)
                .replace(",", "")
        if (earlyRepayDetailBean.totalDueInterest > 0) {
            totalDueInterest_layout.visibility = View.VISIBLE
            totalDueInterest.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.totalDueInterest)
                    .replace(",", "")
        }
        if (earlyRepayDetailBean.totalFeeCouponAmt > 0) {
            totalFeeCouponAmt_layout.visibility = View.VISIBLE
            totalFeeCouponAmt.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.totalFeeCouponAmt)
                    .replace(",", "")
            coupon_tip.setOnClickListener {
                DialogTitleUtils.showDialogTitle(this, getString(R.string.str_dialog_title), getString(R.string.str_early_repay_tip3))
            }
        }

        if (mLoanDetailInfo != null && !TextUtils.isEmpty(mLoanDetailInfo?.repayFeeText)) {
            liquidatedDamages_tip.visibility = View.VISIBLE
            channel_liquidatedDamages_info.text = mLoanDetailInfo?.repayFeeText
        }

        if (earlyRepayDetailBean.liquidatedDamages > 0) {
            liquidatedDamages_layout.visibility = View.VISIBLE
            liquidatedDamages.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.liquidatedDamages)
                    .replace(",", "")
        }

        //提前结清按钮
        when {
            earlyRepayDetailBean.isThisDay -> {
                early_repay.isEnabled = false
                error_msg.text = getString(R.string.str_early_repay_tip2)
            }
            "1" == earlyRepayDetailBean.repayStatus -> {
                early_repay.isEnabled = false
                error_msg.text = getString(R.string.str_early_repay_tip1)
            }
            else -> early_repay.setOnClickListener {

                if (!earlyRepayDetailPresenter!!.isCanAdvance(earlyRepayDetailBean)) {
                    ToastUtil.show(this, getString(R.string.str_advance_repay_hint), Toast.LENGTH_SHORT)
                    return@setOnClickListener
                }
                if (mLoanDetailInfo == null) {
                    return@setOnClickListener
                }
                val earlyRepaymentBean = EarlyRepaymentBean()
                earlyRepaymentBean.amount = mLoanDetailInfo!!.remainAmount
                earlyRepaymentBean.orderNo = orderNo
                earlyRepaymentBean.repayType = earlyRepayDetailBean.repayType
                earlyRepaymentBean.transCurrency = earlyRepayDetailBean.currency
                earlyRepaymentBean.repyam = mLoanDetailInfo!!.repyam
                earlyRepaymentBean.rptlam = mLoanDetailInfo!!.rptlam
                earlyRepaymentBean.proId = earlyRepayDetailBean.prodSubNo
                earlyRepaymentBean.isDue = isDue(earlyRepayDetailBean)
                earlyRepaymentBean.channelCode = SharedPreUtils.getSharedPreferences(this, Constants.CHANNEL_HK_CODE, "")
                val bundle = Bundle()
                bundle.putBoolean(Constants.IS_ADVANCE, true)
                bundle.putSerializable(Constants.LOAN_RECORD_INFO, earlyRepaymentBean)
                bundle.putDouble(Constants.TOTAL_MONEY, mLoanDetailInfo!!.rptlam)
                com.baoyin.utils.Util.startActivity(this, ChannelBankPaymentActivity::class.java, bundle)
            }
        }

        //还款计划
        issue.text = getString(R.string.str_early_repay_issue, earlyRepayDetailBean.remainder.toString(),
                earlyRepayDetailBean.installTotalCnt.toString())
        checkbox.setOnCheckedChangeListener(this)
        if (earlyRepayDetailBean.billRepayplans != null) {
            earlyRepayList.clear()
            earlyRepayList.addAll(earlyRepayDetailBean.billRepayplans)
            mAdapter!!.notifyDataSetChanged()
        }
    }

    fun isDue(earlyRepayDetailBean: EarlyRepayDetailBean?): String {
        return if (earlyRepayDetailBean!!.billRepayplans.any { it.overdueDays > 0 }) "0" else "2"//0有逾期 2无逾期
    }

    override fun getLoanRecordEarlyRepaySuccess(getLoanRecordEarlyRepayResponse: BYChannelProto.GetChannelLoanRecordEarlyRepayResponse?) {
        mLoanDetailInfo = getLoanRecordEarlyRepayResponse
    }

    override fun getLoanRecordEarlyRepayFailed(getLoanRecordEarlyRepayResponse: BYChannelProto.GetChannelLoanRecordEarlyRepayResponse?) {
    }

    override fun onCheckedChanged(p0: CompoundButton?, p1: Boolean) {
        if (p1) {
            repay_plan.visibility = View.VISIBLE
            checkbox.text = getString(R.string.str_early_repay_fold)
            Handler().postDelayed(Runnable {
                scrollView.smoothScrollTo(scrollView.left, ScreenUtil.screenHeight / 2)
            }, 100)
        } else {
            repay_plan.visibility = View.GONE
            checkbox.text = getString(R.string.str_early_repay_unfold)
        }
    }
}
