package com.baoyin.credit.my.activity

import android.graphics.Typeface
import android.os.Bundle
import android.view.View
import baoyin.net.BYCommonProto
import com.baoyin.credit.R
import com.baoyin.credit.base.activity.TitleBarActivity
import com.baoyin.credit.cashloan.borrow.action.ISignAgreementAction
import com.baoyin.credit.cashloan.borrow.action.ISignPaymentAgreementConfirmAction
import com.baoyin.credit.cashloan.borrow.action.PaymentAgreementAction
import com.baoyin.credit.cashloan.borrow.dialog.VerifyBankCardUtils
import com.baoyin.credit.cashloan.borrow.presenter.IsSignPaymentAgreementPresenter
import com.baoyin.credit.cashloan.borrow.presenter.SignPaymentAgreementConfirmPresenter
import com.baoyin.credit.my.action.IBankcard2ActivityAction
import com.baoyin.credit.my.bean.MyBankCardInfo
import com.baoyin.credit.my.presenter.Bankcard2ActivityPresenter
import com.baoyin.credit.my.presenter.CheckUnBindBankCardPresenter
import com.baoyin.credit.my.presenter.UnBindBankCardPresenter
import com.baoyin.credit.safeCenter.util.CustomDialog
import com.baoyin.preference.Constants
import com.baoyin.track.presenter.BuryPointPresenter
import com.baoyin.utils.DialogNoTitleUtils
import com.baoyin.utils.UIHelper
import com.baoyin.utils.Util
import com.baoyin.widget.DeleteBankCardDialogView
import com.baoyin.widget.loadingdialog.CustomProgressLoadingDialog
import com.byxf.media.picture.ImageLoader
import kotlinx.android.synthetic.main.activity_bank_details.*

class BankDetailsActivity : TitleBarActivity(), IBankcard2ActivityAction, PaymentAgreementAction, ISignPaymentAgreementConfirmAction, ISignAgreementAction, DeleteBankCardDialogView.OnDialogClickListener, CheckUnBindBankCardPresenter.OnCheckUnBindCardListener, UnBindBankCardPresenter.OnDeleteBankcardListener {

    override fun signFail(msg: String?) {
        sb_unlock.setCheckedImmediately(false)
        VerifyBankCardUtils.showVerifyBankCardFailDialog(this, this, msg)
    }

    override fun isSign(isSign: Boolean) {
        if (isSign) {
            bankcard2ActivityPresenter!!.setDefaultDebitCard(bankCardInfo)
        } else {
            sb_unlock.setCheckedImmediately(false)
            VerifyBankCardUtils.showVerifyBankCardDialog(this,
                    bankCardInfo!!.bankID,
                    this, reserveMobile,
                    bankCardInfo!!.bankName)
        }
    }

    override fun isSignSuccess(isSign: Boolean, msg: String?) {
        if (isSign) {
            bankcard2ActivityPresenter!!.setDefaultDebitCard(bankCardInfo)
        } else {
            sb_unlock.setCheckedImmediately(false)
            VerifyBankCardUtils.showVerifyBankCardFailDialog(this, this, msg)
        }
    }

    override fun checkCode(code: String?, phone: String?) {
        CustomProgressLoadingDialog.createDialog(mContext, false)
        signPaymentAgreementConfirmPresenter!!.signPaymentAgreementConfirm(phone, code)
    }

    override fun signAgain() {
        VerifyBankCardUtils.showVerifyBankCardDialog(this,
                bankCardInfo!!.bankID,
                this, reserveMobile,
                bankCardInfo!!.bankName)
    }

    override fun GetBindBankCardsSuccess(bankCardInfoList: MutableList<MyBankCardInfo>?, debitCardListInfoList: MutableList<BYCommonProto.BankInfo>?, creditCardListInfoList: MutableList<BYCommonProto.BankInfo>?) {
    }

    override fun isFrequentDeviceLogin(isFrequentDeviceLogin: Boolean) {
    }

    override fun setDefaultDebitCardSuccess(bankId: String?) {
        sb_unlock.setCheckedImmediately(true)
    }

    override fun GetBindBankCardsFailed(statusInfo: BYCommonProto.StatusInfo?) {
    }

    var bankCardInfo: MyBankCardInfo? = null
    var bankcard2ActivityPresenter: Bankcard2ActivityPresenter? = null
    var reserveMobile: String? = null
    private var signPaymentAgreementConfirmPresenter: SignPaymentAgreementConfirmPresenter? = null
    private var isSignPaymentAgreementPresenter: IsSignPaymentAgreementPresenter? = null
    private var checkUnBindBankCardPresenter: CheckUnBindBankCardPresenter? = null
    private var unBindBankCardPresenter: UnBindBankCardPresenter? = null
    private var dialog: CustomDialog? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_bank_details)
        mTitleBarMegTextView.text = "···"
        mTitleBarMegTextView.textSize = 18f
        mTitleBarMegTextView.typeface = Typeface.DEFAULT_BOLD
        mTitleBarMegTextView.visibility = View.VISIBLE
        mTitleBarMegTextView.tag = "titlebar_tv_msg"

        checkUnBindBankCardPresenter = CheckUnBindBankCardPresenter(this, this)
        unBindBankCardPresenter = UnBindBankCardPresenter(this, this)
        signPaymentAgreementConfirmPresenter = SignPaymentAgreementConfirmPresenter(this, this)
        isSignPaymentAgreementPresenter = IsSignPaymentAgreementPresenter(this, this)
        bankCardInfo = intent.extras?.getSerializable(Constants.BANK_CARD_INFO) as MyBankCardInfo?
        bankcard2ActivityPresenter = Bankcard2ActivityPresenter(this, this)
        reserveMobile = bankCardInfo?.reserveMobile
        ImageLoader.with(this).url(bankCardInfo?.bankIconUrlBig).placeHolder(R.drawable.icon_bankcard_default).error(R.drawable.icon_bankcard_default).crossFade().into(iv_bank_icon)

        ImageLoader.with(this).url(bankCardInfo?.waterMark).into(iv_water_mark)
        tv_bank_name.text = "${bankCardInfo?.bankName}${bankCardInfo?.bankCardTypeDesc}"
        tv_bank_num.text = Util.getBankCard(bankCardInfo?.bankID)
        if ("储蓄卡" == bankCardInfo?.bankCardTypeDesc) {
            tv_single_limit.text = bankCardInfo?.singleLimit ?: "-"
            tv_day_limit.text = bankCardInfo?.dayLimit ?: "-"

            sb_unlock.setCheckedImmediately("Y" == bankCardInfo?.deductFlag)
            sb_unlock.setTag("sb_unlock")
            sb_unlock.setOnClickListener {
                val isChecked = sb_unlock.isChecked
                if (isChecked) {
                    //接口请求
                    isSignPaymentAgreementPresenter?.isSignPaymentAgreement(bankCardInfo?.bankID, reserveMobile)
                } else {
                    DialogNoTitleUtils.showDialogNoTitle(this, getString(R.string.str_remind_close_default_debit_card))
                    sb_unlock.setCheckedImmediately(true)
                }
            }
        } else {
            ll_day_limit.visibility = View.GONE
            ll_single_limit.visibility = View.GONE
            ll_switch.visibility = View.GONE
            auto_repay_tip.visibility = View.GONE
        }
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.titlebar_layout_back,
            R.id.titlebar_tv_back -> {
                finish()
            }
            R.id.titlebar_tv_msg -> {
                val bottomDialogView = DeleteBankCardDialogView(this, R.layout.dialog_delete_bankcard, false, false, this)
                bottomDialogView.show()
            }
        }
    }

    override fun deleteBankCard() {
        checkUnBindBankCardPresenter?.checkUnbindBankCard(bankCardInfo?.bankID)
    }

    override fun canUnBindCard(code: String?) {
        showConfirmDialog(code)
    }

    private fun showConfirmDialog(code: String?) {
        val builder = CustomDialog.Builder(this)
        dialog = builder.cancelTouchout(false)
                .view(R.layout.dialog_confirm_delete_bankcard)
                .widthDimenRes(R.dimen.dp_315)
                .heightDimenRes(R.dimen.dp_170)
                .style(R.style.Dialog)
                .addViewOnclick(R.id.negativeButton) {
                    dialog?.dismiss()
                }
                .addViewOnclick(R.id.positiveButton) {
                    dialog?.dismiss()
                    val buryPointPresenter = BuryPointPresenter(this)
                    buryPointPresenter.buryPoint("unbindCardStart", bankCardInfo?.bankID)
                    when (code) {
                        //需要输入交易密码
                        "02" -> {
                            val bundle = Bundle()
                            bundle.putString("bank_serialNo", bankCardInfo?.bankSerialNo)
                            Util.startActivity(this@BankDetailsActivity, DeleteBankcardValidateActivity::class.java, bundle)
                        }
                        //无交易密码，可直接删除
                        "03" -> {
                            unBindBankCardPresenter?.unbindBankCard(bankCardInfo?.bankSerialNo, "")
                        }
                    }
                }.build()
        dialog?.show()
    }

    override fun deleteSuccess() {
        UIHelper.ToastMessage(this, "删除银行卡成功")
        finish()
    }
}
