package com.baoyin.credit.my.activity

import android.os.Bundle
import android.os.Handler
import android.support.v7.widget.LinearLayoutManager
import android.text.TextUtils
import android.view.View
import android.widget.CompoundButton
import android.widget.Toast
import baoyin.net.BYTradeServiceProto
import com.baoyin.credit.R
import com.baoyin.credit.base.activity.TitleBarActivity
import com.baoyin.credit.cashloan.differ.DifferStepsUtil
import com.baoyin.credit.cashloan.differ.grantCredit.action.IDifferAction
import com.baoyin.credit.cashloan.differ.grantCredit.entity.CertificationBean
import com.baoyin.credit.cashloan.differ.grantCredit.presenter.DifferentiationPresenter
import com.baoyin.credit.cashloan.differ.grantCredit.util.CertificationUtils
import com.baoyin.credit.cashloan.tradingrecord.action.ILoanDetailActivityAction
import com.baoyin.credit.cashloan.tradingrecord.presenter.LoanDetailPresenter
import com.baoyin.credit.my.action.EarlyRepayDetailAction
import com.baoyin.credit.my.adapter.EarlyRepayPlanAdapter
import com.baoyin.credit.my.bean.EarlyRepayDetailBean
import com.baoyin.credit.my.presenter.EarlyRepayDetailPresenter
import com.baoyin.net.entity.EarlyRepaymentBean
import com.baoyin.preference.ApplicationLoginInfo
import com.baoyin.preference.ByxfApplication
import com.baoyin.preference.Constants
import com.baoyin.utils.DialogTitleUtils
import com.byxf.utils.DateUtil
import com.byxf.utils.NumberUtil
import com.byxf.utils.ScreenUtil
import com.byxf.utils.ToastUtil
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.*
import kotlinx.android.synthetic.main.activity_tobe_paid_detail.liquidatedDamages_info as liquidatedDamages_info1


/**
 * 提前结清-账单详情
 */
class TobePaidDetailActivity : TitleBarActivity(), EarlyRepayDetailAction,
        CompoundButton.OnCheckedChangeListener, ILoanDetailActivityAction, IDifferAction {

    var mAdapter: EarlyRepayPlanAdapter? = null
    private var loanDetailPresenter: LoanDetailPresenter? = null
    var orderNo: String = ""
    var mLoanDetailInfo: BYTradeServiceProto.GetLoanRecordEarlyRepayResponse? = null
    private var earlyRepayList: MutableList<EarlyRepayDetailBean.GetBillRepayPlan> = ArrayList<EarlyRepayDetailBean.GetBillRepayPlan>()
    private var earlyRepayDetailPresenter: EarlyRepayDetailPresenter? = null
    var earlyRepayDetailBean: EarlyRepayDetailBean? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_tobe_paid_detail)
        mAdapter = EarlyRepayPlanAdapter(this, earlyRepayList)
        repay_plan.layoutManager = LinearLayoutManager(this)
        repay_plan.adapter = mAdapter
        orderNo = intent.extras.getString("orderNo", "")
        loanDetailPresenter = LoanDetailPresenter(this, this)
        loanDetailPresenter!!.queryLoanRecordEarlyRepayInfo(orderNo)
        earlyRepayDetailPresenter = EarlyRepayDetailPresenter(this, this, orderNo)
    }

    override fun getEarlyRepayDetailSuccess(earlyRepayDetailBean: EarlyRepayDetailBean?) {
        this.earlyRepayDetailBean = earlyRepayDetailBean
        total_repayment_amt.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean!!.totalRepaymentAmt)
                .replace(",", "")
        pay_date.text = getString(R.string.str_early_repay_total_amt,
                DateUtil.getDateYearMonthDay(earlyRepayDetailBean.payDate),
                NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.installTotalAmt))
                .replace(",", "")
        totalTransAmt.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.totalTransAmt)
                .replace(",", "")
        currentInterest.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.earlyInterest)
                .replace(",", "")
        if (earlyRepayDetailBean.totalDueInterest > 0) {
            totalDueInterest_layout.visibility = View.VISIBLE
            totalDueInterest.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.totalDueInterest)
                    .replace(",", "")
        }
        if (earlyRepayDetailBean.totalFeeCouponAmt > 0) {
            totalFeeCouponAmt_layout.visibility = View.VISIBLE
            totalFeeCouponAmt.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.totalFeeCouponAmt)
                    .replace(",", "")
            coupon_tip.setOnClickListener {
                DialogTitleUtils.showDialogTitle(this, getString(R.string.str_dialog_title), getString(R.string.str_early_repay_tip3))
            }
        }

        if (earlyRepayDetailBean.liquidatedDamages > 0) {
            liquidatedDamages_layout.visibility = View.VISIBLE
            liquidatedDamages.text = NumberUtil.formatDoubleTwoComma(earlyRepayDetailBean.liquidatedDamages)
                    .replace(",", "")
        }

        if (mLoanDetailInfo != null && !TextUtils.isEmpty(mLoanDetailInfo?.repayFeeText)) {
            liquidatedDamages_tip.visibility = View.VISIBLE
            liquidatedDamages_info1.text = mLoanDetailInfo?.repayFeeText
        }

        //提前结清按钮
        when {
            earlyRepayDetailBean.isThisDay -> {
                early_repay.isEnabled = false
                early_repay.setBackgroundResource(R.drawable.button_gray_shape)
                error_msg.text = getString(R.string.str_early_repay_tip2)
            }
            "1" == earlyRepayDetailBean.repayStatus -> {
                early_repay.isEnabled = false
                early_repay.setBackgroundResource(R.drawable.button_gray_shape)
                error_msg.text = getString(R.string.str_early_repay_tip1)
            }
            else -> early_repay.setOnClickListener {

                if (!earlyRepayDetailPresenter!!.isCanAdvance(earlyRepayDetailBean)) {
                    ToastUtil.show(this, getString(R.string.str_advance_repay_hint), Toast.LENGTH_SHORT)
                    return@setOnClickListener
                }
                if (mLoanDetailInfo == null) {
                    return@setOnClickListener
                }
                if (!ByxfApplication.isHasPayPwd) {
                    val applicationLoginInfo: ApplicationLoginInfo = xsdApp.getApplicationLoginInfo(this)
                    val mDifferPresenter = DifferentiationPresenter(this, this)
                    DifferStepsUtil.getInstance(this).init(CertificationUtils.DIFFERENTIATION_TYPE_CREDIT)
                    mDifferPresenter.processCertification(applicationLoginInfo.getMobilePhoneNumber(), "")
                } else {
                    jumpToBankPayment()
                }

            }
        }

        //还款计划
        issue.text = getString(R.string.str_early_repay_issue, earlyRepayDetailBean.remainder.toString(),
                earlyRepayDetailBean.installTotalCnt.toString())
        checkbox.setOnCheckedChangeListener(this)
        if (earlyRepayDetailBean.billRepayplans != null) {
            earlyRepayList.clear()
            earlyRepayList.addAll(earlyRepayDetailBean.billRepayplans)
            mAdapter!!.notifyDataSetChanged()
        }
    }

    private fun jumpToBankPayment() {
        com.baoyin.utils.Util.startActivity(this, BankPaymentActivity::class.java, getBundle())
    }

    private fun getBundle(): Bundle {
        val earlyRepaymentBean = EarlyRepaymentBean()
        earlyRepaymentBean.amount = mLoanDetailInfo!!.remainAmount
        earlyRepaymentBean.orderNo = orderNo
        earlyRepaymentBean.repayType = earlyRepayDetailBean?.repayType
        earlyRepaymentBean.transCurrency = earlyRepayDetailBean?.currency
        earlyRepaymentBean.repyam = mLoanDetailInfo!!.repyam
        earlyRepaymentBean.rptlam = mLoanDetailInfo!!.rptlam
        earlyRepaymentBean.proId = earlyRepayDetailBean?.prodSubNo
        earlyRepaymentBean.channelCode = com.baoyin.utils.Util.getChannelCode(earlyRepayDetailBean?.prodSubNo)
        earlyRepaymentBean.isDue = isDue(earlyRepayDetailBean)
        val bundle = Bundle()
        bundle.putBoolean(Constants.IS_ADVANCE, true)
        bundle.putSerializable(Constants.LOAN_RECORD_INFO, earlyRepaymentBean)
        bundle.putDouble(Constants.TOTAL_MONEY, mLoanDetailInfo!!.rptlam)
        return bundle
    }

    fun isDue(earlyRepayDetailBean: EarlyRepayDetailBean?): String {
        return if (earlyRepayDetailBean!!.billRepayplans.any { it.overdueDays > 0 }) "0" else "2"//0有逾期 2无逾期
    }

    override fun getLoanRecordEarlyRepayFailed(getLoanRecordEarlyRepayResponse: BYTradeServiceProto.GetLoanRecordEarlyRepayResponse?) {
    }

    override fun getLoanRecordEarlyRepaySuccess(getLoanRecordEarlyRepayResponse: BYTradeServiceProto.GetLoanRecordEarlyRepayResponse?) {
        mLoanDetailInfo = getLoanRecordEarlyRepayResponse
    }

    override fun onCheckedChanged(p0: CompoundButton?, p1: Boolean) {
        if (p1) {
            repay_plan.visibility = View.VISIBLE
            checkbox.text = getString(R.string.str_early_repay_fold)
            Handler().postDelayed(Runnable {
                scrollView.smoothScrollTo(scrollView.left, ScreenUtil.screenHeight / 2)
            }, 100)
        } else {
            repay_plan.visibility = View.GONE
            checkbox.text = getString(R.string.str_early_repay_unfold)
        }
    }

    override fun processCertification(certificationBean: CertificationBean?) {
        val invalidStatusList = certificationBean!!.invalidStatus
        if (invalidStatusList != null && invalidStatusList.size > 0) {
            if (CertificationUtils.CERTIFICATION_STATUS_VALID_ID_CARD == invalidStatusList[0]) {
                jumpToBankPayment()
            } else {
                //执行实名认证步骤
                CertificationUtils.excuteJumpPageByStatusCode(this, invalidStatusList[0], CertificationUtils.TYPE_REPAY, getBundle())
            }
        }
    }
}
